## cppdb 0.3.1%2Bdfsg

=== debian/changelog ===
cppdb (0.3.1+dfsg-6) unstable; urgency=medium

  * Mark -dev-package Multiarch:Same
  * Bump S-V to 4.0.0 -- no changes required

 -- Tobias Frost <tobi@debian.org>  Sun, 09 Jul 2017 14:47:50 +0200

cppdb (0.3.1+dfsg-5) unstable; urgency=medium

  * Change B-D from libmysqlclient-dev to default-libmysqlclient-dev.
  * Bump d/compat level to 10
    - B-D on debhelper >10
    - remove --parallel from d/rules, it is default now

 -- Tobias Frost <tobi@debian.org>  Sat, 22 Oct 2016 19:41:37 +0200

cppdb (0.3.1+dfsg-4) unstable; urgency=medium

  * Bump S-V to 3.9.8 -- no changes required.
  * Replace VCS-Git git:// with https:// URL
  * Replace Homepage with a more informative one
  * Explicitly enable all hardening options

 -- Tobias Frost <tobi@debian.org>  Sun, 11 Sep 2016 13:17:43 +0200

cppdb (0.3.1+dfsg-3) unstable; urgency=medium

  * Upload to unstable.
  * Update years in d/copyright and change also to my Debian email.
  * Move license grants to the license paragraphs to avoid lintian warnings.

 -- Tobias Frost <tobi@debian.org>  Mon, 15 Jun 2015 14:07:21 +0200

cppdb (0.3.1+dfsg-2) experimental; urgency=medium

  * Move git repository to collab-maint (as gitorious will be discontinued).
  * Bump SV -- no changes.
  * Set maintainer to my Debian email.
  * Add license grant to d/copyright, do not install copyright.txt

 -- Tobias Frost <tobi@debian.org>  Wed, 11 Mar 2015 08:59:25 +0100

cppdb (0.3.1+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #753013).

 -- Tobias Frost <tobi@coldtobi.de>  Fri, 01 Aug 2014 23:35:26 +0200
