=== debian/changelog ===
cppdb (0.3.1+dfsg-9) unstable; urgency=medium

  [ Ondřej Nový ]
  * d/watch: Use https protocol

  [ Debian Janitor ]
  * Bump debhelper from old 11 to 12.
  * Set debhelper-compat version in Build-Depends.
  * Set upstream metadata fields: Archive, Repository.
  * Update standards version to 4.2.1, no changes needed.

  [ Tobias Frost ]
  * Enable CI on salsa.
  * Fix field name case in debian/control. (VCS-* => Vcs-*)
  * Fix linitan error description-contains-invalid-control-statement, as
    there was an extra space.
  * Bump compat level to 13 -- no changes.
  * Bump S-V to 4.6.0 -- no changes required.
  * Bump d/watch to version 4.
  * Drop -Wl,--as-needed linker flags, they are default now.

 -- Tobias Frost <tobi@debian.org>  Tue, 19 Oct 2021 16:21:37 +0200

cppdb (0.3.1+dfsg-8) unstable; urgency=medium

  * Drop the symbols files again. It is just not sustainable.
    (Closes: #906456)
  * Adding lintian overrides for the missing symbol files.
  * Bump S-V to 4.2.0 (adding Rules-Requires-Root)

 -- Tobias Frost <tobi@debian.org>  Thu, 23 Aug 2018 19:55:38 +0200

cppdb (0.3.1+dfsg-7) unstable; urgency=medium

  * Upload to unstable.

 -- Tobias Frost <tobi@debian.org>  Sat, 05 May 2018 09:53:47 +0200

cppdb (0.3.1+dfsg-7~exp6) experimental; urgency=medium

  * Fix typo in symbols file.

 -- Tobias Frost <tobi@debian.org>  Sat, 14 Apr 2018 11:17:54 +0200

cppdb (0.3.1+dfsg-7~exp5) experimental; urgency=medium

  * Another try on symbols, should hopefully fix them for ppc64el and powerpc.

 -- Tobias Frost <tobi@debian.org>  Sat, 14 Apr 2018 08:39:44 +0200

cppdb (0.3.1+dfsg-7~exp4) experimental; urgency=medium

  * Really drop pkg-kde-tools from B-D.
    (it had been removed from d/rules, but not from d/control)
  * Temporarily (as experimental) build B-D on debhelper 11.2.1
    as it fixes the cmake problem.

 -- Tobias Frost <tobi@debian.org>  Sun, 08 Apr 2018 11:34:30 +0200

cppdb (0.3.1+dfsg-7~exp3) experimental; urgency=medium

  * Drop pkg-kde-tools from B-D

 -- Tobias Frost <tobi@debian.org>  Sun, 08 Apr 2018 01:06:33 +0200

cppdb (0.3.1+dfsg-7~exp2) experimental; urgency=medium

  * Working on symbols files -- failed as expected.
    Trying again with pkg-kde-tools

 -- Tobias Frost <tobi@debian.org>  Sat, 07 Apr 2018 23:36:06 +0200

cppdb (0.3.1+dfsg-7~exp1) experimental; urgency=medium

  * Upload to experimental because for test-compile to
    get symbols for all archs.
  * Move repository to salsa.d.o.
  * Update meta-data from the patch.
  * Bump compat level to 11 and B-D on debhelper >= 11.
  * Bump S-V to 4.1.3:
    * The change that get-orig-source is depreciated makes
      README.Source obsolete, thus removed.
    * Moved the reason for repacking to d/copyright
  * Updated copyright years and switch to https:// links where possible.
  * Remove lintian overrides to give symbol files another try.
  * Also package the example in the -dev package.

 -- Tobias Frost <tobi@debian.org>  Thu, 05 Apr 2018 22:27:59 +0200
