=== debian/rules ===
--- 
+++ 
@@ -6,11 +6,9 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
-export DEB_LDFLAGS_MAINT_APPEND := -Wl,--as-needed
 
 %:
 	dh $@
 
 override_dh_auto_configure:
 	dh_auto_configure -- -DLIBDIR=lib/$(DEB_HOST_MULTIARCH) -DODBC_BACKEND_INTERNAL=OFF
-
