=== debian/watch ===
version=4
opts=dversionmangle=s/\+dfsg(\.\d+)?$// \
https://sf.net/cppcms/cppdb-(.*)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
